// Copyright 2021 TNO
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Package smartcontract implements the coordinator using a set of Ethereum smart contracts.
//
// Generating the Go bindings to the smart contracts
//
// The smart contract interface requires bindings to go-ethereum, which is boilerplate code
// that can be automatically generated by `abigen`.
//
// This is done by installing `abigen` and `solc`. The latter should be downloaded as a
// binary from Github, as long as we don't update our code for 0.7.0 compatibility.
//     https://github.com/ethereum/solidity/releases/tag/v0.6.12
// The former is acquired using
//     go get -u github.com/ethereum/go-ethereum
//     cd $GOPATH/src/github.com/ethereum/go-ethereum/
//     make
//     make devtools
//
// When done, you can generate new `.abi` files with
//     solc --overwrite -o output_dir --abi --bin <filename>.sol
// and generate the bindings using
//     abigen -abi PPAPresence.abi -pkg smartcontract -type Presence -out presence.go
//     abigen -abi PPAQuery.abi -pkg smartcontract -type Query -out query.go
// If you are missing methods in one of your bindings, check that the `.abi` file does not
// begin with `[]` and a line of `====...`. If it does, remove the first three lines.
//
// This package contains go generate instructions that perform the above task for you.
// To run them, run the "go generate" command from the location of this file.
package smartcontract

// Go generate does not support globbing (i.e. *.sol). Therefore, we hard-code all contract paths.

//go:generate -command compile solc --overwrite -o generated --abi --bin
//go:generate compile ../../../smartcontracts/contracts/PPAQuery.sol
//go:generate compile ../../../smartcontracts/contracts/PPAPresence.sol
//go:generate compile ../../../smartcontracts/contracts/DiamondStart.sol
//go:generate compile ../../../smartcontracts/contracts/DiamondFacet.sol

//go:generate abigen --bin=generated/PPAQuery.bin --abi=generated/PPAQuery.abi --pkg=smartcontract --type=Query --out=query.go
//go:generate abigen --bin=generated/PPAPresence.bin --abi=generated/PPAPresence.abi --pkg=smartcontract --type=Presence --out=presence.go
//go:generate abigen --bin=generated/DiamondStart.bin --abi=generated/DiamondStart.abi --pkg=smartcontract --type=DiamondStart --out=diamondstart_test.go
//go:generate abigen --bin=generated/DiamondFacet.bin --abi=generated/DiamondFacet.abi --pkg=smartcontract --type=DiamondFacet --out=diamondfacet_test.go

import (
	"context"
	"io"
	"math/big"
	"sync"

	"github.com/rs/zerolog/log"

	"ci.tno.nl/gitlab/ppa-project/pkg/coordinator"
	sc "ci.tno.nl/gitlab/ppa-project/pkg/scbindings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// The Coordinator maintains the connection to the blockchain.
// Obtain one by calling NewCoordinator, register any number of
// event listeners using RegisterQueryListener and RegisterNodeConfigListener
// and start the node using ConnectAndListen.
type Coordinator struct {
	// The Coordinator mutex protects the member variables of the coordinator
	// and must be taken before any changes can be made.
	sync.Mutex
	// Current connection status
	Status Status
	// Main blockchain bindings
	config        coordinator.Config
	connection    Connection
	smartContract *SmartContract
	// Transaction options for writing to the blockchain
	wallet *bind.TransactOpts
	// Channel of log messages that need to be written to the blockchain
	logsIn chan OutgoingLog
	// Logs that need to be written, when disconnected
	logsBackup []OutgoingLog
	// Cache of audit logs. Contains its own Mutex for inner fields;
	// the Coordinator mutex does not need to be taken when using those.
	auditLogs AuditLogs
	// Event subscriptions for messages from the blockchain
	subscriptions []event.Subscription
	// Listeners for the various types of events
	queryListeners         []coordinator.QueryListener
	presenceListeners      []coordinator.NodeConfigListener
	guiListeners           []coordinator.GuiConfigListener
	auditLogEntryListeners []coordinator.AuditLogEntryListener
}

type Connection interface {
	bind.ContractBackend
	ethereum.ChainStateReader
	NetworkID(context.Context) (*big.Int, error)
	BlockByNumber(context.Context, *big.Int) (*types.Block, error)
	TransactionReceipt(ctx context.Context, txHash common.Hash) (*types.Receipt, error)
	Close()
}

type SmartContract struct {
	sc.Presence
	sc.Query
	sc.Maintenance
}

// Status holds the current connection status of a Coordinator
type Status int

const (
	Disconnected Status = iota
	Connecting
	Connected
	WaitingToReconnect
)

// NewCoordinator makes a new smart contract controller.
func NewCoordinator(config coordinator.Config) *Coordinator {
	scc := &Coordinator{
		Status:        Disconnected,
		config:        config,
		logsIn:        make(chan OutgoingLog),
		logsBackup:    make([]OutgoingLog, 0),
		subscriptions: make([]event.Subscription, 0),
	}

	// Wait for log events from ZeroLog to be submitted and write those to the smart contract
	go scc.logLoop()
	return scc
}

// Adds a QueryListener to the controller. When a new query is emitted by the smart
// contract, it calls IncomingQuery on each registered listener.
func (scc *Coordinator) RegisterQueryListener(ql coordinator.QueryListener) {
	scc.Lock()
	defer scc.Unlock()
	scc.queryListeners = append(scc.queryListeners, ql)
}

// Adds a NodeConfigListener to the controller. When a new node configuration is emitted
// by the smart contract, it calls NodeConfigurationUpdate on each registered listener.
// In addition, ConnectAndListen will call NodeConfigurationUpdate on each listener for
// the most recent configuration of each organization, so be sure to register any listeners
// before calling ConnectAndListen.
func (scc *Coordinator) RegisterNodeConfigListener(nl coordinator.NodeConfigListener) {
	scc.Lock()
	defer scc.Unlock()
	scc.presenceListeners = append(scc.presenceListeners, nl)
}

// Adds a GuiConfigListener to the controller. When a new GUI configuration is emitted
// by the smart contract, it calls GuiConfigurationUpdate on each registered listener.
// In addition, ConnectAndListen will call GuiConfigurationUpdate on each listener for
// the most recent configuration of the current organization, so be sure to register
// any listeners before calling ConnectAndListen.
func (scc *Coordinator) RegisterGuiConfigListener(nl coordinator.GuiConfigListener) {
	scc.Lock()
	defer scc.Unlock()
	scc.guiListeners = append(scc.guiListeners, nl)
}

// Adds a AuditLogEntryListener to the controller. When a new auditlog entry is emitted
// by the smart contract, it calls AuditLogEntryListener on each registered listener.
func (scc *Coordinator) RegisterAuditLogEntryListener(alel coordinator.AuditLogEntryListener) {
	scc.Lock()
	defer scc.Unlock()
	scc.auditLogEntryListeners = append(scc.auditLogEntryListeners, alel)
}

// Produces a CoordinatorWriter writing to the smart contract connected to this
// controller. See the documentation of CoordinatorWriter.Write for details.
func (scc *Coordinator) Writer() io.Writer {
	return &Writer{scc.logsIn}
}

// UpdateNodeConfig takes the given parameters, combines them with existing data passed
// at the Coordinator's creation in coordinator.Config, and issues a node registration event
// with the smart contract.
func (scc *Coordinator) UpdateNodeConfig(ip, port, cert, paillierkey string) error {
	// Set up a filtering event iterator
	iter, err := scc.smartContract.FilterMPCNodeRegistered(&bind.FilterOpts{Start: 1})
	if err != nil {
		log.Err(err).Msg("Unable to access past node registration events")
		return err
	}
	defer iter.Close()

	// Find and save the most recent config update for each org
	var presence *sc.PresenceMPCNodeRegistered
	for iter.Next() {
		if iter.Event.NodeData.Organization == scc.config.Organization {
			presence = iter.Event
		}
	}
	if iter.Error() != nil {
		log.Err(iter.Error()).Msg("An error occurred while accessing past node registration events")
		return iter.Error()
	}

	if presence != nil &&
		presence.NodeData.Attributes != nil &&
		presence.NodeData.Ip == scc.config.Ip &&
		presence.NodeData.Port == scc.config.Port &&
		presence.NodeData.Cert == scc.config.Cert &&
		presence.NodeData.Paillierkey == scc.config.PaillierKey &&
		presence.NodeData.DbHash == scc.config.DbHash {

		interpretedAttributes := AttributesFromStrings(presence.NodeData.Attributes)
		if interpretedAttributes.Equal(&scc.config.Attributes) {
			log.Debug().Msg("smartcontract: Own node config already up to date")
			return nil
		}
	}

	scc.config.Ip, scc.config.Port, scc.config.Cert, scc.config.PaillierKey = ip, port, cert, paillierkey
	return scc.registerMPCNode()
}

// UpdateGuiConfig takes the given parameters, combines them with existing data passed
// at the Coordinator's creation in coordinator.Config, and issues a GUI registration event
// with the smart contract.
func (scc *Coordinator) UpdateGuiConfig(ip, cert string) error {
	// Set up a filtering event iterator
	iter, err := scc.smartContract.FilterGUINodeRegistered(&bind.FilterOpts{Start: 1})
	if err != nil {
		log.Err(err).Msg("Unable to access past GUI registration events")
		return err
	}
	defer iter.Close()

	// Find and save the most recent config update for each org
	var presence *sc.PresenceGUINodeRegistered
	for iter.Next() {
		if iter.Event.NodeData.Organization == scc.config.Organization {
			presence = iter.Event
		}
	}
	if iter.Error() != nil {
		log.Err(iter.Error()).Msg("An error occurred while accessing past GUI registration events")
		return iter.Error()
	}

	if presence != nil &&
		presence.NodeData.Ip == scc.config.Ip &&
		presence.NodeData.Cert == scc.config.Cert {
		log.Debug().Msg("smartcontract: Own GUI config already up to date")
		return nil
	}
	scc.config.Ip, scc.config.Cert = ip, cert
	return scc.registerGUINode()
}

// UpdateHealth implements the listener interface of the coordinator
// Function is called when a Health update occurs
func (scc *Coordinator) UpdateHealth(nodeName string, healthy bool, err error) error {
	// We do not support this for the smartcontract
	return nil
}

func (scc *Coordinator) GetBusinessRules() []string {
	rules := make([]string, 0)
	var err error = nil
	var i *big.Int = new(big.Int)
	for err == nil {
		var rule string
		rule, err = scc.RuleExplanation(i)
		if err == nil {
			rules = append(rules, rule)
			i.Add(i, new(big.Int).SetInt64(1))
		}
	}
	return rules
}
